package com.example.zcatalyst_sdk

import android.content.Context
import androidx.annotation.NonNull

import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MethodChannel

/** ZcFlutterSdkPlugin */
class ZCatalystSDKPlugin : FlutterPlugin {

    private lateinit var channel: MethodChannel

    private var CHANNEL_NAME =
        "${IAMSDKConstants.MethodChannel.DOMAIN}/${IAMSDKConstants.MethodChannel.NAME}"

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        setUpChannel(flutterPluginBinding.binaryMessenger, flutterPluginBinding.applicationContext)
    }

    fun setUpChannel(messenger: BinaryMessenger, applicationContext: Context) {
        channel = MethodChannel(messenger, CHANNEL_NAME)
        val methodCallHandler: MethodCallHandler = MethodCallHandler(applicationContext)
        channel.setMethodCallHandler(methodCallHandler)
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        channel.setMethodCallHandler(null)
    }
}
