//
//  ZCatalystSDKConfigs.swift
//  zcatalyst_sdk
//
//  Created by vignesh-pt5452 on 16/12/22.
//

import Foundation

struct ZCatalystSDKConfigs: Decodable
{
    var clientID: String
    var clientSecretID: String
    var jwtClientID: String = IAMSDKConstants.configPropertyNotAvailable
    var jwtClientSecret: String = IAMSDKConstants.configPropertyNotAvailable
    var accountsURL: String
    var portalID: String
    internal var oAuthScopeString: String
    var OAuthScopes:Array<String> {
        return self.oAuthScopeString.components(separatedBy: ",")
    }
    private var redirectURL: String
    var redirectURLScheme: String{
        return self.redirectURL + "://"
    }
    var apiBaseURL: String
    var apiVersion: String
    var projectID: String
    var requestHeaders: Dictionary<String, String>

    private enum CodingKeys: String, CodingKey {
        case clientID = "ClientID"
        case clientSecretID = "ClientSecretID"
        case accountsURL = "AccountsPortalDomain"
        case jwtClientID = "JWTClientID"
        case jwtClientSecret = "JWTClientSecret"
        case redirectURL = "RedirectURLScheme"
        case oAuthScopeString = "OAuthScopes"
        case portalID = "PortalID"
        case apiBaseURL = "APIBaseURL"
        case apiVersion = "APIVersion"
        case projectID = "ProjectID"
        case requestHeaders = "RequestHeaders"
    }

}
