part of '../api_request.dart';

class FunctionAPIHandler {
  String identifier;

  FunctionAPIHandler({required this.identifier});

  Future<void> executeFunctionGET(
      {required Map<String, dynamic>? params,
      required Function(APIResponse response, String output) onSuccess,
      required Function(ZCatalystException exception) onFailed}) async {
    await APIRequest._(
      endPoint: '${Endpoints.FUNCTION}/$identifier/execute',
      method: HttpMethod.GET,
      params: params,
    )._sendRequest(
        onSuccess: (APIResponse response) {
          var responseData = response.responseJson[APIConstant.OUTPUT];
          onSuccess(response, responseData);
        },
        onFailed: onFailed);
  }

  Future<void> executeFunctionPOST(
      {required Map<String, dynamic> body,
      required Function(APIResponse response, String output) onSuccess,
      required Function(ZCatalystException exception) onFailed}) async {
    await APIRequest._(
      endPoint: '${Endpoints.FUNCTION}/$identifier/execute',
      method: HttpMethod.POST,
      body: body,
    )._sendRequest(
        onSuccess: (APIResponse response) {
          var responseData = response.responseJson[APIConstant.OUTPUT];
          onSuccess(response, responseData);
        },
        onFailed: onFailed);
  }

  Future<void> executeFunctionPUT(
      {required Map<String, dynamic> params,
      required Map<String, dynamic> body,
      required Function(APIResponse response, String output) onSuccess,
      required Function(ZCatalystException exception) onFailed}) async {
    await APIRequest._(
      endPoint: '${Endpoints.FUNCTION}/$identifier/execute',
      method: HttpMethod.PUT,
      body: body,
    )._sendRequest(
        onSuccess: (APIResponse response) {
          var responseData = response.responseJson[APIConstant.OUTPUT];
          onSuccess(response, responseData);
        },
        onFailed: onFailed);
  }

  Future<void> executeFunctionDELETE(
      {required Map<String, dynamic> params,
      required Map<String, dynamic> body,
      required Function(APIResponse response) onSuccess,
      required Function(ZCatalystException exception) onFailed}) async {
    await APIRequest._(
      endPoint: '${Endpoints.FUNCTION}/$identifier/execute',
      method: HttpMethod.DELETE,
    )._sendRequest(
        onSuccess: (APIResponse response) {
          onSuccess(response);
        },
        onFailed: onFailed);
  }
}
