part of 'base_api_response.dart';

class APIResponse extends BaseAPIResponse {
  APIResponse(this.response) : super(response);

  Response response;

  @override
  void _processResponse() {
    var json = jsonDecode(response.body);
    if (ResponseCode.faultyResponseCodes.contains(statusCode)) {
      _handleFaultyResponses(json);
    } else {
      _processDataResponse(json);
    }
  }

  @override
  void _setResponseJSON() {
    if (!(statusCode == ResponseCode.NO_CONTENT_AVAILABLE)) {
      responseJson = jsonDecode(response.body);
    }
  }

  void _processDataResponse(dynamic json) {
    if (json is Map<String, dynamic>) {
      if ((json.containsKey(APIConstant.DATA) &&
              json[APIConstant.DATA] == null) ||
          (json.containsKey(APIConstant.OUTPUT) &&
              json[APIConstant.OUTPUT] == null)) {
        throw ZCatalystException(
            code: ErrorCode.NO_CONTENT_AVAILABLE,
            errorMessage: ErrorMessage.NO_CONTENT_AVAILABLE);
      }
    }
  }
}
