class ZCatalystColumn {
  ///The unique **id** of the column.
  int id;

  ///The **name** of the column.
  String name;

  ///Whether this column is a required column?
  bool isMandatory;

  ///Whether this column should contain only unique values?
  bool isUnique;

  ///Whether this column has the search index enabled to perform catalyst **search** operation?
  bool isSearchIndexEnabled;

  ///The data type of the column.
  String dataType;

  ///The maximum length of the value that this column will hold.
  int? maxLength;

  ///The order of this column when created.
  int sequence;

  ///The number of decimal digits that are allowed to be placed after the decimal point.
  int? decimalDigits;

  /// The Category of this column.
  ///
  ///- **1** - If the column is a system-defined column.
  ///- **2** - If the column is a user-defined column.
  int category;

  ///The default value for the column if no value is inserted.
  String? defaultValue;

  ///The foreign-key constraint type for this column.
  ///
  ///Possible Values : **ON-DELETE-SET-NULL**, **ON-DELETE-CASCADE**.
  String? constraintType;

  ZCatalystColumn(
      {required this.id,
      required this.name,
      required this.sequence,
      required this.category,
      required this.dataType,
      required this.maxLength,
      required this.isMandatory,
      required this.decimalDigits,
      required this.isUnique,
      required this.isSearchIndexEnabled,
      required this.defaultValue,
      required this.constraintType});
}
