import 'zcatalyst_role.dart';
import 'zcatalyst_user_delegate.dart';

class ZCatalystUser extends ZCatalystUserDelegate {
  ///The unique **id** of the zoho user account.
  String zuid;

  ///The unique **id** of the organization that this end-user belongs to.
  String zaaid;

  ///The first name of the user.
  String firstName;

  ///The unique **id** of the user.
  String id;

  ///The type of the user.
  ///
  ///Possible Values: **App User**, **App Admin**
  String userType;

  String status;

  ///Whether the user is a confirmed user?
  bool isConfirmed;

  ///The time in Date-Time format at which the current user is created.
  String createdTime;

  ///The last modified time of the current user's details.
  String modifiedTime;

  ///The time in Date-Time format at which the current user is invited.
  String invitedTime;

  ///The details of the role assigned to this user in the form of [ZCatalystRole] object.
  ZCatalystRole roleDetails;

  ZCatalystUser({
    required String emailId,
    required String lastName,
    required this.zuid,
    required this.zaaid,
    required this.firstName,
    required this.id,
    required this.userType,
    required this.status,
    required this.isConfirmed,
    required this.createdTime,
    required this.modifiedTime,
    required this.invitedTime,
    required this.roleDetails,
  }) : super(lastName, emailId);

  Map<String, dynamic> toJson() => {
        "zuid": zuid,
        "zaaid": zaaid,
        "first_name": firstName,
        "last_name": lastName,
        "email_id": emailId,
        "is_confirmed": isConfirmed,
        "status": status,
        "user_id": id,
        "user_type": userType,
        "created_time": createdTime,
        "modified_time": modifiedTime,
        "invited_time": invitedTime,
        "role_id": roleDetails.id,
        "role_name": roleDetails.name,
      };
}
