class ZCatalystException implements Exception {
  final String _code;

  String? _errorMessage;

  Exception? _originalException;

  Map<String, dynamic>? _errorDetails;

  String get code => _code;

  Map<String, dynamic>? get errorDetails => _errorDetails;

  ZCatalystException(
      {required String code,
      String? errorMessage,
      Map<String, dynamic>? errorDetails,
      Exception? originalException})
      : _code = code {
    _errorMessage = errorMessage;
    _errorDetails = errorDetails;
    _originalException = originalException;
  }

  String? getErrorMessage() {
    return _originalException?.toString() ?? _errorMessage;
  }

  @override
  String toString() {
    String returnMsg =
        '$runtimeType. Caused by : $_code - ${getErrorMessage()}';
    if (_errorDetails != null && _errorDetails!.isNotEmpty) {
      returnMsg += ' - $_errorDetails';
    }
    return returnMsg;
  }
}
