import '../util/api_constants.dart';
import 'package:logger/logger.dart';

class ZCatalystLogger {
  static late Logger _logger;

  static initLogger() {
    _logger = Logger(
      printer: PrettyPrinter(
        methodCount: 0,
        colors: false,
        noBoxingByDefault: true,
        printEmojis: false,
      ),
    );
  }

  static void logVerbose(String message) {
    _logger.v(APIConstant.LOG_MSG + message);
  }

  static void logDebug(String message) {
    _logger.d(APIConstant.LOG_MSG + message);
  }

  static void logInfo(String message) {
    _logger.i(APIConstant.LOG_MSG + message);
  }

  static void logWarning(String message) {
    _logger.w(APIConstant.LOG_MSG + message);
  }

  static void logError(String message) {
    _logger.e(APIConstant.LOG_MSG + message);
  }
}
