import '../api/response/base_api_response.dart';
import '../api/api_request.dart';
import '../exception/zcatalyst_exception.dart';

class ZCatalystFunction {
  final String _identifier;

  ZCatalystFunction(this._identifier);

  Future<void> executeGET(
      {Map<String, dynamic>? params,
      required Function(APIResponse response, String output) onSuccess,
      required Function(ZCatalystException exception) onFailed}) async {
    await FunctionAPIHandler(identifier: _identifier).executeFunctionGET(
        params: params, onSuccess: onSuccess, onFailed: onFailed);
  }

  Future<void> executePOST(
      {required Map<String, dynamic> body,
      required Function(APIResponse response, String output) onSuccess,
      required Function(ZCatalystException exception) onFailed}) async {
    await FunctionAPIHandler(identifier: _identifier).executeFunctionPOST(
        body: body, onSuccess: onSuccess, onFailed: onFailed);
  }

  Future<void> executePUT(
      {required Map<String, dynamic> params,
      required Map<String, dynamic> body,
      required Function(APIResponse response, String output) onSuccess,
      required Function(ZCatalystException exception) onFailed}) async {
    await FunctionAPIHandler(identifier: _identifier).executeFunctionPUT(
        params: params, body: body, onSuccess: onSuccess, onFailed: onFailed);
  }

  Future<void> executeDELETE(
      {required Map<String, dynamic> params,
      required Map<String, dynamic> body,
      required Function(APIResponse response) onSuccess,
      required Function(ZCatalystException exception) onFailed}) async {
    await FunctionAPIHandler(identifier: _identifier).executeFunctionDELETE(
        params: params, body: body, onSuccess: onSuccess, onFailed: onFailed);
  }
}
