class APIConstant {
  static const String BASE_URL = 'api.catalyst.zoho.com';
  static const String URL_PATH = 'baas';
  static const String URL = 'URL';
  static const String HEADERS = 'HEADERS';
  static const String AUTHORIZATION = 'Authorization';
  static const String AUTHORIZATION_TYPE = 'Zoho-oauthtoken';
  static const String CONTENT_TYPE = 'content-type';
  static const String JSON_CONTENT_TYPE = 'application/json';
  static const String PORTAL_ID = 'project_id';
  static const String PARAMS = 'PARAMS';
  static const String REQUEST_BODY = 'REQUEST_BODY';
  static const String DATA = 'data';
  static const String STATUS = 'data';
  static const String ERROR = 'error';
  static const String ERROR_CODE = 'error_code';
  static const String OUTPUT = 'output';
  static const String MESSAGE = 'message';
  static const String LOG_MSG = "ZCatalyst_SDK_LOG ::: ";
  static const int MAX_ALLOWED_FILE_SIZE_IN_MB = 100;
  static const String DATE = 'date';
  static const String USER_DETAILS = 'user_details';
  static const int INT_MOCK = -555;
  static const String STRING_MOCK = 'SDK_NULL';
  static const String MAX_ROWS_PARAM = 'max_rows';
  static const String NEXT_TOKEN_PARAM = 'next_token';
  static const String SCOPES = 'scopes';
  static const String JWT_TOKEN_CLIENT_TYPE = 'type';
  static const String MOBILE = 'mobile';
  static const String TIMEZONE = 'timezone';
}

class Endpoints {
  static const String USER = 'project-user';
  static const String TABLE = 'table';
  static const String ROW = 'row';
  static const String COLUMN = 'column';
  static const String FUNCTION = 'function';
}

class MethodChannelConstants {
  static const String CHANNEL_DOMAIN = "catalyst.zoho.com";
  static const String CHANNEL = "iam_sdk";
  static const String METHOD_CALL_INIT = "init";
  static const String METHOD_CALL_INIT_WITH_CONFIGS = "initWithSDKConfigs";
  static const String METHOD_CALL_LOGIN = "login";
  static const String METHOD_CALL_SIGN_UP = "signUp";
  static const String METHOD_CALL_GET_ACCESS_TOKEN = "getAccessToken";
  static const String METHOD_CALL_IS_USER_LOGGED_IN = "isUserLoggedIn";
  static const String METHOD_CALL_LOGOUT = "logout";
  static const String METHOD_CALL_GET_JWT_CLIENT_DETAILS =
      "get_jwt_client_details";
  static const String METHOD_CALL_GET_OAUTH_TOKEN_WITH_JWT_TOKEN =
      "get_oauth_token_with_jwt_token";
}

class MethodChannelArguments {
  static const String ACCOUNTS_PORTAL_URL = 'accountsPortalBaseURL';
  static const String REDIRECT_URL_SCHEME = 'redirectURLScheme';
  static const String CLIENT_ID = 'clientID';
  static const String CLIENT_SECRET = 'clientSecret';
  static const String PORTAL_ID = 'portalID';
  static const String SCOPES = 'oauthScopes';
  static const String ENVIRONMENT = 'environment';
  static const String IS_CUSTOM_LOGIN = 'isCustomLogin';
  static const String URL = 'url';
  static const String CUSTOM_PARAMS = 'customParams';
  static const String JWT_TOKEN = 'jwtToken';
}

class SDKConfigKeys {
  static const String REDIRECT_URL_SCHEME = "redirect_url_scheme";
  static const String CLIENT_ID = "client_id";
  static const String CLIENT_SECRET = "client_secret";
  static const String PORTAL_ID = "portal_id";
  static const String API_BASE_URL = "api_base_url";
  static const String PROJECT_ID = "project_id";
  static const String PRINT_STACK_TRACE = "print_stacktrace";
  static const String REQUEST_HEADERS = "requestHeaders";
  static const String JWT_CLIENT_ID = "jwt_client_id";
  static const String JWT_CLIENT_SECRET = "jwt_client_secret";
  static const String ACCOUNTS_PORTAL_DOMAIN = "accounts_portal_domain";
  static const String SCOPES = "scopes";
}

class ErrorCode {
  static const INITIALIZATION_ERROR = "INITIALIZATION_ERROR";
  static const LOGIN_ERROR = "LOGIN_ERROR";
  static const SIGNUP_ERROR = "SIGNUP_ERROR";
  static const LOGOUT_FAILED = "LOGOUT_FAILED";
  static const TOKEN_FETCH_ERROR = "TOKEN_FETCH_ERROR";
  static const RESPONSE_PARSE_ERROR = "RESPONSE_PARSE_ERROR";
  static const NO_NETWORK_AVAILABLE = "NO_NETWORK_AVAILABLE";
  static const API_FAILED = "API_FAILED";
  static const INVALID_DATA = "INVALID_DATA";
  static const FILE_SIZE_EXCEEDED = "FILE_SIZE_EXCEEDED";
  static const FUNCTION_EXECUTION_ERROR = "FUNCTION_EXECUTION_ERROR";
  static const JSON_EXCEPTION = "JSON_EXCEPTION";
  static const INVALID_REQUEST = "INVALID_REQUEST";
  static const INVALID_FILE_INPUT = "INVALID_FILE_INPUT";
  static const INTERNAL_ERROR = "INTERNAL_ERROR";
  static const INVALID_OPERATION = "INVALID_OPERATION";
  static const NO_CONTENT_AVAILABLE = "NO_CONTENT_AVAILABLE";
  static const INVALID_CONFIGURATION = 'INVALID_CONFIGURATION';
}

class ErrorMessage {
  static const INITIALIZATION_ERROR =
      "Zoho Catalyst SDK must be initialized for this operation.";
  static const String INVALID_CONFIGURATION_FOR_DEFAULT_LOGIN =
      'The SDK has not been initialized with the configuration required for the default login. Reinitialize the SDK with the appropriate configuration for the default login.';
  static const String INVALID_CONFIGURATION_FOR_CUSTOM_LOGIN =
      "The SDK has not been initialized with the configuration required for the custom login. Reinitialize the SDK with the appropriate configuration for the custom login.";
  static const MANDATORY_CONFIG_MISSING =
      "Please ensure all mandatory properties are given values.";
  static const RESPONSE_PARSE_ERROR = "Error while parsing response.";
  static const FILE_UNAVAILABLE = "File seems to be unavailable.";
  static const OFFLINE = "The Internet connection appears to be offline.";
  static const LOGOUT_FAILED = "LOGOUT FAILED, PLEASE TRY AGAIN LATER.";
  static const FILE_SIZE_EXCEEDED =
      "File size is more than the allowed size of.";
  static const INVALID_DATA = "The given data seems to be invalid.";
  static const PROVIDE_VALID_DATA = "Please provide valid data for.";
  static const BODY_UNAVAILABLE = "For PUT/POST Request Body MUST not be NULL.";
  static const INPUTSTREAM_EMPTY =
      "File Input stream MUST NOT be Empty for Upload operation.";
  static const INVALID_DATA_FORMAT = "Invalid Data Format.";
  static const CREATE_ONLY_OPERATION =
      "This initialization is applicable only for CREATE.";
  static const INVALID_ID = "The given ID seems to be invalid.";
  static const HTML_PAGE_AS_REPONSE = "Something went wrong.";
  static const NO_CONTENT_AVAILABLE =
      "The request returned an empty or null response.";
}

class ResponseCode {
  static const int OK = 200;
  static const int CREATED = 201;
  static const int ACCEPTED = 202;
  static const int API_LIMIT_REACHED = 403;
  static const int FUNCTION_ERROR = 202;
  static const int INVALID_CONTENT = 403;
  static const int INVALID_ID = 404;
  static const int INVALID_INPUT = 400;
  static const int INVALID_NAME = 400;
  static const int INVALID_OPERATION = 403;
  static const int INVALID_REQUEST_METHOD = 405;
  static const int MISSING_FUNCTION = 400;
  static const int NO_ACCESS = 401;
  static const int NO_CONTENT_AVAILABLE = 204;
  static const int UNAUTHORIZED = 401;
  static const int TOO_MANY_REQUESTS = 200;

  static List<int> faultyResponseCodes = [
    API_LIMIT_REACHED,
    FUNCTION_ERROR,
    INVALID_CONTENT,
    INVALID_ID,
    INVALID_INPUT,
    INVALID_NAME,
    INVALID_OPERATION,
    INVALID_REQUEST_METHOD,
    MISSING_FUNCTION,
    NO_ACCESS,
    NO_CONTENT_AVAILABLE,
    UNAUTHORIZED,
  ];
}
